/*!
 * @file element_2d.h
 * @brief Definition of the 2D elements rendered on top through the GraphicsEngine
*/

#ifndef _ELEMENT_2D_H
#define _ELEMENT_2D_H

#include "base_object.h"

// FORWARD DECLARATION

//!< An enumerator defining the Depth of a 2D-element.
typedef enum
{
  E2D_TOP,                             //!< Will be rendered on top of everything else
  E2D_MEDIUM,                          //!< Will be rendered on the medium Layer.
  E2D_BOTTOM,                          //!< Will be rendered on the bottom Layer
  E2D_BELOW_ALL                        //!< Will be rendered below the 3D-scene. @todo make this work.
} E2DLayer;

//! A class for ...
class Element2D : public BaseObject {

 public:
  Element2D();
  virtual ~Element2D();


  void setPosition(int xCoord, int yCoord);
  void setLayer(E2DLayer layer);


  virtual void draw() const = NULL;

 private:
   bool               visible;
   int                position2D[2];    //!< X-coord, Y-Coord
   E2DLayer           layer;

};


#endif /* _ELEMENT_2D_H */
